Index: main/trunk/greenstone3/web/interfaces/default/transform/config_format.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/config_format.xsl	(revision 31560)
+++ main/trunk/greenstone3/web/interfaces/default/transform/config_format.xsl	(revision 31563)
@@ -231,17 +231,5 @@
 					</xsl:if>
 
-					<xslt:attribute name='href'>
-						<xslt:value-of select='$library_name'/>
-						<xsl:text>/collection/</xsl:text>
-						<xslt:value-of select='/page/pageResponse/collection/@name'/>
-						<xsl:text>/browse/</xsl:text>
-						<xsl:choose>
-							<xsl:when test="@nodeID">
-								<xsl:value-of select="@nodeID"/>
-							</xsl:when>
-							<xsl:otherwise>
-								<xslt:value-of select='util:replace(@nodeID, ".", "/")'/>
-							</xsl:otherwise>
-						</xsl:choose>
+					<xslt:attribute name='href'><xslt:call-template name="classifierNodeLink"><xsl:if test="@style"><xslt:with-param name="link-type"><xsl:value-of select="@style"/></xslt:with-param></xsl:if><xsl:if test="@nodeID"><xslt:with-param name="node-id" select="@nodeID"/></xsl:if></xslt:call-template>
 					</xslt:attribute>
 					<xsl:copy-of select="$opt-title"/>
Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl	(revision 31560)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/classifier.xsl	(revision 31563)
@@ -22,4 +22,5 @@
   <!-- optional cgi-params for links to document pages -->
   <xsl:variable name="opt-doc-link-args"></xsl:variable>
+
   <!-- the page content -->
   <xsl:template match="/page/pageResponse">
@@ -154,5 +155,5 @@
 		    <xsl:if test="not(/page/pageResponse/format[@type='browse']/gsf:option[@name='turnstyleClassifiers']) or /page/pageResponse/format[@type='browse']/gsf:option[@name='turnstyleClassifiers']/@value='true'">
 		      <td class="headerTD">
-			<img id="toggle{@nodeID}" onclick="toggleSection('{@nodeID}');" class="icon">			
+			<img id="toggle{@nodeID}" onclick="toggleSection('{@nodeID}');" class="icon turnstyleicon">			
 			  <xsl:attribute name="src">
 			    <xsl:choose>
@@ -279,40 +280,47 @@
   -->
   <xsl:template match="classifierNode[@classifierStyle = 'HList']" >
-    <gsf:link type="classifier">
+    <gsf:link type="classifier" style="static">
       <xsl:value-of disable-output-escaping="yes"  select="metadataList/metadata[@name='Title']"/>
     </gsf:link>
   </xsl:template>
 
-  <xsl:template match="classifierNode"><!-- priority="3"-->
-
-    <!--<table id="title{@nodeID}"><tbody><tr>-->
+  <xsl:template match="classifierNode">
     <!-- Bookshelf icon -->
     <td>
+      <gsf:link type="classifier" style="static">
       <img>
 	<xsl:attribute name="src"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'bookshelf_image')"/></xsl:attribute>
       </img>
+      </gsf:link>
     </td>
     <!-- Link title -->
     <td>
-      <a href="javascript:toggleSection('{@nodeID}');">
+      <gsf:link type="classifier">
 	<xsl:value-of disable-output-escaping="yes"  select="metadataList/metadata[@name='Title']"/>
-      </a>
-    </td>
-    <!--</tr></tbody></table>-->
-    
-    <!-- Show any documents or sub-groups in this group -->
-    <!--	<xsl:if test="documentNode|classifierNode">
-	<div id="div{@nodeID}" class="classifierContainer">
-	<table>
-	<xsl:for-each select="documentNode|classifierNode">
-	<tr>
-	<xsl:apply-templates select="."/>
-	</tr>
-	</xsl:for-each>
-	</table>
-	</div>
-	</xsl:if>-->
-  </xsl:template>
-  
+      </gsf:link>
+    </td>
+  </xsl:template>
+  
+  <xsl:template name="classifierNodeLink">
+    <xsl:param name="link-type">dynamic</xsl:param>
+    <xsl:param name="node-id"></xsl:param>
+    <xsl:variable name="final-link-type">
+      <xsl:choose>
+	<xsl:when test="$link-type='static'">static</xsl:when>
+	<xsl:when test="$link-type='javascript'">javascript</xsl:when>
+	<xsl:when test="@classifierStyle = 'HList'">static</xsl:when>
+	<xsl:when test="not(/page/pageResponse/format[@type='browse']/gsf:option[@name='turnstyleClassifiers']) or /page/pageResponse/format[@type='browse']/gsf:option[@name='turnstyleClassifiers']/@value='true'">javascript</xsl:when>
+	<xsl:otherwise>static</xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+    <xsl:choose>
+      <xsl:when test="$final-link-type='static'">
+	<xsl:value-of select='$library_name'/>/collection/<xsl:value-of select='/page/pageResponse/collection/@name'/>/browse/<xsl:choose><xsl:when test="$node-id"><xsl:value-of select="$node-id"/></xsl:when><xsl:otherwise><xsl:value-of select='util:replace(@nodeID, ".", "/")'/></xsl:otherwise></xsl:choose>
+      </xsl:when>
+      <xsl:otherwise>javascript:toggleSection('<xsl:value-of select="@nodeID"/>');</xsl:otherwise>
+    </xsl:choose>	
+  </xsl:template>
+
+
   <xsl:template name="classifierPre">
     <xsl:if test="/page/pageResponse/format[@type='display' or @type='browse' or @type='search']/gsf:option[@name='mapEnabled']/@value = 'true'">
@@ -335,33 +343,8 @@
   </xsl:template>
   
-  
-  <xsl:template name="bookshelfimg">
-    <xsl:param name="alt"/>
-    <xsl:param name="title"/>
-    <img border="0" width="20" height="16" src="interfaces/default/images/bshelf.gif" alt="{$alt}" title="{$title}"/>
-  </xsl:template>
-
-
   <xsl:template match="/page/xsltparams">
     <!-- suppress xsltparam block in page -->
   </xsl:template>
 
-  <!-- is this ever used? copied from classifier tools and renamed xxxOld -->
-  <xsl:template match="documentNodeOld">
-    <xsl:param name="collName"/>
-    <xsl:param name="serviceName"/>
-    <a href="{$library_name}?a=d&amp;c={$collName}&amp;d={@nodeID}&amp;dt={@docType}&amp;p.a=b&amp;p.s={$serviceName}"><xsl:apply-templates select="." mode="displayNodeIcon"/></a><xsl:value-of disable-output-escaping="yes"  select="metadataList/metadata[@name='Title']"/>
-  </xsl:template>
-  
-  
-  <!-- icon + title template-->
-  <!-- is this ever used??? copied from classifier tools and renamed xxxOld???  -->
-  <xsl:template match="classifierNodeOld">
-    <xsl:param name="collName"/>
-    <xsl:param name="serviceName"/>
-    <a><xsl:attribute name='href'><xsl:value-of select='$library_name'/>?a=b&amp;rt=r&amp;s=<xsl:value-of select='$serviceName'/>&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@nodeID'/><xsl:if test="classifierNode|documentNode">.pr</xsl:if></xsl:attribute><xsl:call-template name="bookshelfimg"/></a><xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='Title']"/>
-  </xsl:template>
-  
-
 </xsl:stylesheet>
 