Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.css
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.css	(revision 31524)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.css	(revision 31570)
@@ -1,2 +1,8 @@
+table.query-table tr td {
+    padding-top: 4px;
+    padding-bottom: 4px;
+    padding-right: 6px;
+}
+
 .show-hide-lang {
     display: none;
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html	(revision 31524)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html	(revision 31570)
@@ -294,6 +294,7 @@
             
     <div class="container">
-      <h4>Admin Resources</h4>
+      <h4>Additional Resources</h4>
       <ul>
+	<li><a href="stream-query.html">Combined Volume Metadata and Page-levelPOS Term searching</a></li>
 	<li><a href="admin.html">HTRC-EF Solr Admin UI (log in)</a></li>
 	<li><a href="luke_lang_mappings.html">Dynamically Generated Language Map (Part-of-Speech, and Other)</a></li>
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.js
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.js	(revision 31524)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.js	(revision 31570)
@@ -57,4 +57,21 @@
 }
 
+function stream_generate_item(line,id,title)
+{
+    var css_class = (line%2 == 0) ? 'class="evenline"' : 'class="oddline"';
+    
+    var html_item = "";
+
+
+    var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+0;
+
+    html_item += '<p ' + css_class + '>';
+    //html_item += ' <span style="font-style: italic;" name="'+id+'"></span><br>';
+    html_item += '<a target="_blank" href="' + babel_url + '">' + id + ': ' + title + '</a>';
+    html_item += '</p>';
+
+    return html_item;
+}
+
 
 function generate_item(line,id,id_pages)
@@ -105,9 +122,7 @@
 }
 
-function show_results(jsonData) {
-    var response = jsonData.response;
-    var num_found = response.numFound;
-    var docs = response.docs;
-    var num_docs = docs.length;
+function stream_show_results(jsonData) {
+    var docs = jsonData["result-set"].docs;
+    var num_docs = docs.length -1;
 
     $('.search-in-progress').css("cursor","auto");
@@ -116,16 +131,26 @@
 
     if (num_docs>0) {
-	$search_results.html("<p>Results: " + num_found + " pages matched</p>");
+	$search_results.html("<p>Results: " + num_docs + " volumes matched</p>");
+	/*
 	var from = parseInt(store_search_args.start);
 	var to = from + num_rows;
 	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
+	*/
     }
     else {
-	$search_results.html("<p>No pages matched your query</p>");
-    }
-
-    
-    // https://babel.hathitrust.org/cgi/pt?id=hvd.hnnssu;view=1up;seq=11
-
+	$search_results.html("<p>No volumes matched your query</p>");
+    }
+
+    for (var i=0; i<num_docs; i++) {
+	var doc = docs[i];
+	var id = doc.id;
+	var title = doc.title_t;
+
+	var html_item = stream_generate_item(i,id,title);
+	$search_results.append(html_item);
+    }
+    return;
+    // ****
+    
     var htids = [];
 
@@ -155,13 +180,4 @@
 	}
 	
-//	var css_class = (i%2 == 0) ? 'class="evenline"' : 'class="oddline"';
-//	//var restful_safe_id = id.replace(/\./g,",").replace(/:/g, "+").replace(/\//g, "=");
-	
-//	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+seqnum;
-
-//	var result_item = '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
-//	result_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span>';
-//	$search_results.append('<p ' + css_class + '>'+result_item+'</p>');
-
 	htids.push("htid:"+id);
 
@@ -203,8 +219,260 @@
 }
 
+
+function show_results(jsonData) {
+    var response = jsonData.response;
+    var num_found = response.numFound;
+    var docs = response.docs;
+    var num_docs = docs.length;
+
+    $('.search-in-progress').css("cursor","auto");
+    
+    var $search_results = $('#search-results');
+
+    if (num_docs>0) {
+	$search_results.html("<p>Results: " + num_found + " pages matched</p>");
+	var from = parseInt(store_search_args.start);
+	var to = from + num_rows;
+	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
+    }
+    else {
+	$search_results.html("<p>No pages matched your query</p>");
+    }
+
+    
+    // https://babel.hathitrust.org/cgi/pt?id=hvd.hnnssu;view=1up;seq=11
+
+    var htids = [];
+
+    var prev_id = null;
+    var prev_pages = [];
+    
+    var i=0;
+    var line_num = 0;
+    while (i<num_docs) {
+//    for (var i=0; i<num_docs; i++) {
+	var doc = docs[i];
+	var id_and_page = doc.id.split(".page-");
+	var id = id_and_page[0];
+	var seqnum = parseInt(id_and_page[1]);
+	var page = seqnum+1;
+
+	if ((prev_id != null) && (id != prev_id)) {
+	    // time to output previous item
+	    var html_item = generate_item(line_num,prev_id,prev_pages);
+	    $search_results.append(html_item);
+	    line_num++;
+	    prev_pages = [page];
+	}
+	else {
+	    // accumulate pages
+	    prev_pages.push(page)
+	}
+	
+//	var css_class = (i%2 == 0) ? 'class="evenline"' : 'class="oddline"';
+//	//var restful_safe_id = id.replace(/\./g,",").replace(/:/g, "+").replace(/\//g, "=");
+	
+//	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+seqnum;
+
+//	var result_item = '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
+//	result_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span>';
+//	$search_results.append('<p ' + css_class + '>'+result_item+'</p>');
+
+	htids.push("htid:"+id);
+
+	prev_id = id;
+	i++;
+    }
+    
+    var html_item = generate_item(line_num,prev_id,prev_pages);
+    $search_results.append(html_item);
+
+    
+    document.location.href="#search-results-anchor";
+    
+    var next_prev = '<p style="width:100%;"><div id="search-prev" style="float: left;"><a>&lt; Previous</a></div><div id="search-next" style="float: right;"><a>Next &gt;</a></div></p>';
+    
+    $search_results.append(next_prev);
+    $('#search-prev').click(function(event) { show_new_results(-1*num_rows); });
+    $('#search-next').click(function(event) { show_new_results(num_rows); });
+
+    var search_start = store_search_args.start;
+    if (search_start==0) {
+	$('#search-prev').hide();
+    }
+    
+    // Example URL for catalog metadata (multiple items)
+    // http://catalog.hathitrust.org/api/volumes/brief/json/id:552;lccn:70628581|isbn:0030110408
+
+    var htids_str = htids.join("|",htids);
+    var cat_url = "http://catalog.hathitrust.org/api/volumes/brief/json/" + htids_str;
+    	$.ajax({
+	    url: cat_url,
+	    dataType: 'jsonp',
+	    jsonpCallback: "add_titles"
+	});
+
+
+    //var json_pretty = JSON.stringify(jsonData.response, null, '\t');
+    //$('#search-results').text(json_pretty)
+}
+
 var store_search_args = null;
 var store_search_action = null;
 
 var group_by_vol_checked = 0;
+
+function stream_submit_action(event)
+{
+    event.preventDefault();
+
+    $('.search-in-progress').css("cursor","wait");
+
+    var vq_text     = $('#vq').val();
+    
+    store_search_action = $('#search-form').attr("action");
+    
+    var arg_indent = $('#indent').attr('value');
+    var arg_wt     = $('#wt').attr('value');
+    var arg_start  = $('#start').attr('value');
+    var arg_rows   = $('#rows').attr('value');
+    var q_text     = $('#q').val();
+
+    group_by_vol_checked = $('#group-results-by-id:checked').length;
+
+    
+    if ((q_text === "") && (vq_text === "")) {
+	$('.search-in-progress').css("cursor","auto");
+	alert("No query term entered");
+	return;
+    }
+
+    var expr_all = "";
+    var expr_md = "";
+    var expr_tx = "";
+    
+    if (vq_text !== "") {
+	// simplified case of issuing a volume-based metadata query
+	//expr=search(col,q,fl,sort,rows)
+
+    
+	//var expr = "expr=search(";
+	expr_md = "search(";
+	expr_md += "htrc-full-ef20";
+	expr_md += ",q=\""+vq_text+"\"";
+	expr_md += ",fl=\"volumeid_s,id,title_t\"";
+	expr_md += ",sort=\"id asc"+"\"";
+	expr_md += ",indent=\""+arg_indent+"\"";
+	expr_md += ",wt=\""+arg_wt+"\"";
+	expr_md += ",start=\""+arg_start+"\"";
+	expr_md += ",rows=\""+arg_rows+"\"";
+	expr_md += ")";
+	
+	store_search_args = { q: vq_text, indent: arg_indent, wt: arg_wt,
+			      start: arg_start, rows: arg_rows };
+    }
+
+    if (q_text !== "") {
+	
+	var fields = [];
+	var universal_pos_tags = [ "VERB", "NOUN", "ADJ", "ADV", "ADP", "CONJ", "DET", "NUM", "PRT", "X" ];
+
+	var arg_q = "";
+	
+	var split_q_text = q_text.split(/\s+/);
+	for (var qi=0; qi<split_q_text.length; qi++) {
+	    q_text = split_q_text[qi];
+	    
+	    for (var li=0; li<langs_with_pos.length; li++) {
+		var lang = langs_with_pos[li];
+		var lang_enabled_id = lang + "-enabled";
+		var $lang_enabled_cb = $('#'+lang_enabled_id);
+		if ($lang_enabled_cb.is(':checked')) {
+		    console.log("Extracting POS tags for: " + lang);
+		    
+		    for (var ti=0; ti<universal_pos_tags.length; ti++) {
+			var tag = universal_pos_tags[ti];
+			var lang_tag_id = lang+"-"+tag+"-htrctoken-cb";
+			var $lang_tag_cb = $('#'+lang_tag_id);
+			if ($lang_tag_cb.is(':checked')) {
+			    //var lang_tag_field = "xxxx"+lang+"_"+tag+"_htrctoken";
+			    var lang_tag_field = lang+"_"+tag+"_htrctoken";
+			    fields.push(lang_tag_field+":"+q_text);
+			}
+		    }
+		}
+	    }
+	    
+	    for (var li=0; li<langs_without_pos.length; li++) {
+		var lang = langs_without_pos[li];
+	    var lang_enabled_id = lang + "-enabled";
+		var $lang_enabled_cb = $('#'+lang_enabled_id);
+		
+		if ($lang_enabled_cb.is(':checked')) {
+		    console.log("Adding in non-POS field for: " + lang);
+		    //var lang_tag_field = "xxxx"+lang+"_htrctoken";
+		    var lang_tag_field = lang+"_htrctoken";
+		    fields.push(lang_tag_field+":"+q_text);	    
+		}
+	    }
+	
+	    if (fields.length == 0) {
+		alert("No languages selected");
+		return;
+	    }
+
+	    if (qi>0) {
+		arg_q += " OR ";
+	    }
+	    
+	    arg_q += fields.join(" OR ");
+    
+	} // end of for each split q_text
+	
+	// Example search on one of the htrc-full-ef fields is: 
+	//  q=en_NOUN_htrctoken:farming
+	
+	store_search_args = { q: arg_q, indent: arg_indent, wt: arg_wt, start: arg_start, rows: arg_rows };
+
+	store_search_args.sort="id asc";
+	store_search_args.fl="volumeid_s,id";
+	
+	var expr_tx = "search(htrc-full-ef20";
+	
+	for (var k in store_search_args) {
+	    if (store_search_args.hasOwnProperty(k)) {
+		var v = store_search_args[k];
+		expr_tx += "," + k + "=\"" + v + "\"";
+	    }
+	}
+	expr_tx += ")";
+    }
+    
+
+    if ((expr_md != "") && (expr_tx != "")) {
+	expr = "expr=intersect(" + expr_md + "," + expr_tx  + ", on=\"id=volumeid_s\")";
+    }
+    else if (expr_md != "") {
+	expr = "expr=" + expr_md;
+    }
+    else if (expr_tx != "") {
+	expr = "expr=" + expr_tx;
+    }
+    else {
+	// both empty
+	console.log("Warning: query was empty");
+    }
+    
+
+    $.ajax({
+	type: 'GET',
+	url: store_search_action,
+	data: expr,
+	dataType: 'json',
+	success: stream_show_results,
+	error: ajax_error
+    });
+
+}
 
 function submit_action(event)
@@ -437,6 +705,12 @@
 
     generate_other_langs();
-    
-    $('#search-submit').click(submit_action);
+
+    if ($('#search-submit').length>0) {
+	$('#search-submit').click(submit_action);
+    }
+    
+    if ($('#stream-search-submit').length>0) {
+	$('#stream-search-submit').click(stream_submit_action);
+    }
 
 });
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/stream-query.html
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/stream-query.html	(revision 31570)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/stream-query.html	(revision 31570)
@@ -0,0 +1,423 @@
+<!DOCTYPE html>
+<html><head>
+<meta http-equiv="content-type" content="text/html; charset=windows-1252">
+
+        <title>HTRC Extracted Feature Solr Search</title>
+        <link rel="shortcut icon" href="https://analytics.hathitrust.org/assets/images/favicon.ico">
+        <meta name="viewport" content="width=device-width, initial-scale=1.0">
+
+        <!-- Bootstrap -->
+        <link href="HTRC_Mashup--Home_files/bootstrap.css" rel="stylesheet" media="screen">
+        <link href="HTRC_Mashup--Home_files/main.css" rel="stylesheet" media="screen">
+        <link href="HTRC_Mashup--Home_files/flat.css" rel="stylesheet" media="screen">
+        <link href="HTRC_Mashup--Home_files/font-awesome.css" rel="stylesheet">
+        <link href="HTRC_Mashup--Home_files/tomorrow.css" rel="stylesheet">
+	<link href="HTRC_Mashup--Home_files/jquery-ui-lightness-1.12.1/jquery-ui.min.css" rel="stylesheet">
+	
+        <link href="index.css" rel="stylesheet">
+	
+        <script src="HTRC_Mashup--Home_files/highlight.js"></script>
+        <script src="HTRC_Mashup--Home_files/jquery.js"></script>
+	<script src="HTRC_Mashup--Home_files/jquery-ui-lightness-1.12.1/jquery-ui.min.js"></script>
+        <script src="HTRC_Mashup--Home_files/stupidtable.js"></script>
+        <script src="HTRC_Mashup--Home_files/bootstrap.js"></script>
+        <script src="HTRC_Mashup--Home_files/bowser.js"></script>
+        <script type="text/javascript" src="HTRC_Mashup--Home_files/htrcwarnings.js"></script>
+        <script type="text/javascript" src="HTRC_Mashup--Home_files/uploadws.js"></script>
+        <script type="text/javascript" src="HTRC_Mashup--Home_files/ga-download-tracking.js"></script>
+	
+	<script src="iso-639-1.js"></script> <!-- defined var 'isoLangs' -->
+	<script src="index.js"></script>
+  </head>
+  <body>
+        <nav class="navbar navbar-default navbar-fixed-top navbar-htrc" role="navigation">
+            <div class="container">
+                <div class="navbar-header">
+                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
+                        <span class="sr-only">Toggle navigation</span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                    </button>
+                    <a class="navbar-brand" href="https://analytics.hathitrust.org/"><img src="HTRC_Mashup--Home_files/hathi.jpg" style="padding-right : 5 px ; margin-top : - 1 px ;" alt=" " height="32" width="36">
+                        HTRC Portal
+                    </a>
+                </div>
+
+                <div class="navbar-collapse collapse">
+                    <ul class="nav navbar-nav">
+                        <li><a href="https://analytics.hathitrust.org/">Home</a></li>
+                        
+
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Worksets <b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listuserworksets')">View my worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listallworksets')">View all worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/uploadworkset')">Upload workset</a></li>
+                                
+                                <li class="divider"></li>
+                                <li>
+                                    <a href="#" onclick="blacklightLoggingWarning ( '      https://analytics.hathitrust.org/blacklight ')">
+                                        Create workset</a>
+                                </li>
+                            </ul>
+                        </li>
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listalgorithms')">Algorithms</a></li>
+                        
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listjobs')">Results</a></li>
+                        
+                        
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Capsule<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Data+Capsule">
+                                        Documentation</a>
+                                    </li>
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/listvms')">
+                                            Show Capsules</a></li>
+                                    
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/createvms')">
+                                            Create Capsule</a></li>
+                                    
+                                </ul>
+                            </li>
+                        
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Data<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="https://analytics.hathitrust.org/features">
+                                    Extracted Features Dataset</a>
+                                </li>
+                                <li><a href="https://analytics.hathitrust.org/genre">
+                                    Word Frequencies in English-Language Literature, 1700-1922</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Help<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+User+Getting+Started+FAQ">
+                                    Knowledge Base</a>
+                                </li>
+                                <li class="divider"></li>
+                                <li><a href="mailto:htrc-help@hathitrust.org?Subject=Contact">
+                                    Contact</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li><a href="https://analytics.hathitrust.org/about">About</a>
+                    </li></ul>
+                    
+                        <ul class="nav pull-right navbar-nav">
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Sign In<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="https://analytics.hathitrust.org/login">Sign In</a></li>
+                                    <li class="divider"></li>
+                                    <li><a href="https://analytics.hathitrust.org/passwordresetmail">
+                                        Forgot Password?</a></li>
+                                </ul>
+                            </li>
+
+
+                            <li><a href="https://analytics.hathitrust.org/signup"><span>Sign Up</span></a></li>
+                        </ul>
+                    
+                </div>
+                    <!--/.nav-collapse -->
+            </div>
+        </nav>
+        
+        
+
+    <div class="container container-panel" style="padding-top: 15px; padding-bottom: 15px;">
+        <div class="row">
+            <div class="col-md-2 col-sm-2 hidden-xs">
+                <img class="img-responsive" src="HTRC_Mashup--Home_files/hathi.jpg" alt=" ">
+            </div>
+            <div class="col-md-10 col-sm-10 col-xs-12 col-lg-8" style="margin-left: 0;">
+                <h1 style="font-weight:bold;font-size:56px">
+                    HTRC Extracted Feature Solr Search
+                </h1>
+            </div>
+        </div>
+        <div class="row" style="padding-top : 25px; font-size : 17px; line-height : 27px;">
+            <div class="col-md-12">
+
+	      <h2>Combined: Volume Metadata + Page-based Unigram Extracted Features</h2>
+	      <!--
+	      intersect(
+	      search(htrc-full-ef20,q="title_t:Recueil",fl="volumeid_s,id,title_t",sort="id asc",rows=2000),
+	      search(htrc-full-ef20,q="fr_htrctoken:voiture",fl="volumeid_s,id",sort="id asc",rows=2000),
+	      on="id=volumeid_s")
+
+	      solr/htrc-full-ef20/stream?_=1489993732395&expr=
+		-->
+	      
+	      <form action="htrc-full-ef20/stream" id="search-form">
+		<input type="hidden" id="indent" name="indent" value="on"/>
+		<input type="hidden" id="wt" name="wt" value="json"/>
+		<input type="hidden" id="start" name="start" value="0"/>
+		<input type="hidden" id="rows" name="rows" value="2000"/>
+		<table class="query-table">
+		  <tr>
+		    <td>Volume Metadata:</td>
+		    <td><input type="text"   class="search-in-progress" id="vq" name="vq"
+			       placeholder="metaname:metavalue e.g., title_t:farming"
+			       style="width: 600px;"/></td>
+		  </tr>
+		  <tr>
+		    <td></td>
+		    <td style="color: #aaaaaa; width: 400px; font-size: 14px; line-height: 16px; padding-bottom: 10px;">
+		      Indexed volume metadata fields: accessProfile_t, genre_t, imprint_t, isbn_t, issn_t, issuance,
+		      language_t, lccn_t, names_t, oclc_t, pubPlace_t, pubDate_t, rightsAttributes_t,
+		      title_t, typeOfResource_t
+		    </td>
+		  </tr>
+		  <!--
+		  <tr><td>&nbsp;</td><td></td></tr>
+		  -->
+		  <tr>
+		    <td>Page-level text:</td>
+		    <td><input type="text"   class="search-in-progress" id="q" name="q"
+			       style="width: 600px;"/></td>
+		  </tr>
+		  <tr>
+		    <td></td>
+		    <td >
+		      <input type="submit" class="search-in-progress" id="stream-search-submit" style="float: right;"/>
+		    </td>
+		  </tr>
+		</table>
+
+		<!--
+		<br><input type="checkbox" id="group-results-by-id" name="group-results-by-vol" value="on">Group by Volume
+-->
+		
+		<div id="pos-fieldsets">
+		</div>
+		
+<!--
+		<fieldset>
+		  <legend style="margin-bottom: 5px; padding-top: 15px;">
+		    <input type="checkbox" name="en-enabled" id="en-enabled" checked="checked" />
+		    English:
+		  </legend>
+		  <div id="en-pos-choice">
+		  <input type="checkbox" name="en-VERB-htrctoken-cb" id="en-VERB-htrctoken-cb">
+		  <label for="en-VERB-htrctoken-cb"
+			 title="Verbs (all tenses and modes)">Verbs</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-NOUN-htrctoken-cb" id="en-NOUN-htrctoken-cb">
+		  <label for="en-NOUN-htrctoken-cb"
+			 title="Nouns (common and proper)">Nouns</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-ADJ-htrctoken-cb" id="en-ADJ-htrctoken-cb">
+		  <label for="en-ADJ-htrctoken-cb">Adjectives</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-ADV-htrctoken-cb" id="en-ADV-htrctoken-cb">
+		  <label for="en-ADV-htrctoken-cb">Adverbs</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-ADP-htrctoken-cb" id="en-ADP-htrctoken-cb">
+		  <label for="en-ADP-htrctoken-cb"
+			 title ="adpositions (prepositions and postpositions)">Adpositions</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-CONJ-htrctoken-cb" id="en-CONJ-htrctoken-cb">
+		  <label for="en-CONJ-htrctoken-cb">Conjunction</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-DET-htrctoken-cb" id="en-DET-htrctoken-cb">
+		  <label for="en-DET-htrctoken-cb">Determiners</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-NUM-htrctoken-cb" id="en-NUM-htrctoken-cb">
+		  <label for="en-NUM-htrctoken-cb"
+			 title="Cardinal numbers">Numbers</label>
+		  &nbsp;
+		  <input type="checkbox" name="en-PRT-htrctoken-cb" id="en-PRT-htrctoken-cb">
+		  <label for="en-PRT-htrctoken-cb"
+			 title="Particles or other function words">Particles</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-X-htrctokde-cb-" id="de-X-htrctokde-cb-10">
+		  <label for="en-X-htrctoken-cb0"
+			 title="Other words, such as foreign words, typos, abbreviations">Other</label>
+		  </div>
+		</fieldset>
+
+
+		<fieldset>
+		  <legend style="margin-bottom: 5px; padding-top: 15px;">
+		    <input type="checkbox" name="de-enabled" id="de-enabled" />
+		    German:
+		  </legend>
+		  <div id="de-pos-choice">
+		  <input type="checkbox" name="de-VERB-htrctokde-cb" id="de-VERB-htrctokde-cb">
+		  <label for="de-VERB-htrctokde-cb"
+			 title="Verbs (all tenses and modes)">Verbs</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-NOUN-htrctokde-cb" id="de-NOUN-htrctokde-cb">
+		  <label for="de-NOUN-htrctokde-cb"
+			 title="Nouns (common and proper)">Nouns</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-ADJ-htrctokde-cb" id="de-ADJ-htrctokde-cb">
+		  <label for="de-ADJ-htrctokde-cb">Adjectives</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-ADV-htrctokde-cb" id="de-ADV-htrctokde-cb">
+		  <label for="de-ADV-htrctokde-cb">Adverbs</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-ADP-htrctokde-cb" id="de-ADP-htrctokde-cb">
+		  <label for="de-ADP-htrctokde-cb"
+			 title ="adpositions (prepositions and postpositions)">Adpositions</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-CONJ-htrctokde-cb" id="de-CONJ-htrctokde-cb">
+		  <label for="de-CONJ-htrctokde-cb">Conjunction</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-DET-htrctokde-cb" id="de-DET-htrctokde-cb">
+		  <label for="de-DET-htrctokde-cb">Determiners</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-NUM-htrctokde-cb" id="de-NUM-htrctokde-cb">
+		  <label for="de-NUM-htrctokde-cb"
+			 title="Cardinal numbers">Numbers</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-PRT-htrctokde-cb" id="de-PRT-htrctokde-cb">
+		  <label for="de-PRT-htrctokde-cb"
+			 title="Particles or other function words">Particles</label>
+		  &nbsp;
+		  <input type="checkbox" name="de-X-htrctokde-cb-" id="de-X-htrctokde-cb-10">
+		  <label for="de-X-htrctokde-cb0"
+			 title="Other words, such as foreign words, typos, abbreviations">Other</label>
+		  </div>
+		</fieldset>
+-->
+
+                <div id="search-results-anchor"> 
+		</div>
+
+		<fieldset class="show-hide-lang">
+		  <legend style="margin-bottom: 5px; padding-top: 15px;">
+		    Other Languages (without modelled parts-of-speech)
+		  </legend>
+		  <div id="other-langs">
+		  </div>
+		</fieldset>
+
+	      </form>
+
+
+	    </div>
+        </div>
+
+	<hr />
+	<div id="search-results">
+	</div>
+	
+    </div>
+
+
+            
+    <div class="container">
+      <h4>Admin Resources</h4>
+      <ul>
+	<li><a href="admin.html">HTRC-EF Solr Admin UI (log in)</a></li>
+	<li><a href="luke_lang_mappings.html">Dynamically Generated Language Map (Part-of-Speech, and Other)</a></li>
+	<!--
+	<li><a href="/solr/htrc-full-ef_shard6_replica1/admin/luke">Luke XML on shard</a></li>
+-->
+	<li><a href="/solr/htrc-full-ef20_shard6_replica1/admin/luke">Luke XML on shard</a></li>
+      </ul>
+    </div>
+
+	
+        <div class="container">
+        <p style="text-align: center; font-size: small; margin-top: 10px;">HTRC Portal (<a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Service+Release+v3.1+for+Uncamp+2015" target="_blank">v3.2.x</a>)
+        </p>
+        </div>
+
+        
+        <div id="push"></div>
+        
+        
+        <div class="modal fade" id="create-collection-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
+                        <h4 class="modal-title">Create Workset</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You are being redirected to the Workset 
+Builder.
+                            If this is the first time accessing it 
+during this browser session,
+                            you will need to select "Login" from the 
+top-right menu bar before creating or modifying a workset.
+                            We are aware this is inconvenient and we're 
+working on a technical solution to eliminate this requirement.</p>
+                    </div>
+                    <div class="modal-footer">
+                        <span class="pull-left" style="padding-top : 5 px ;"><input id="dont-show" style="margin : - 3 px 0 0 ;" type="checkbox">
+                            Don't Show This Again.</span>
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-wb-url" href="" class="btn btn-sm btn-primary" onclick="goToCreateCollection ( )">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+        <div class="modal fade" id="login-required-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
+                        <h4 class="modal-title">Please Sign in</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You need to sign in to access this functionality.</p>
+                    </div>
+                    <div class="modal-footer">
+                        
+                        
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-target-url" href="" data-toggle="modal" class="btn btn-sm btn-primary">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+
+	<!--
+        <script>
+            (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
+            (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
+            m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
+            })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
+
+            ga('create', 'UA-42842720-8', 'auto');
+            ga('send', 'pageview');
+        </script>
+	-->
+	
+  
+
+
+
+
+
+</body></html>